﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.IO;

namespace W509CS
{
 
    class PicMemory
    {
        //private:
        //int m_nProgSize2;
        //int m_nConfSize2;
        //int m_nDataSize2;

        //int m_ProgMemAddr;    // 0x0000
        //int m_ConfMemAddr;    // 0x4000
        //int m_DataMemAddr;    // 0x4200
        public PicDevice Device { get; private set; }

        public Int16[] ProgMem { get; set; }
        public Int16[] DataMem { get; set; }
        public Int16[] ConfMem { get; set; }
  
 
        public Int16[] CalibDatas {get; set;}
        //public Int16 CalibData2 {get; set;}

        // private 
        //hexline *m_pHexLine;
        //private HexLine m_pHexLine = null;
        private int m_codeSize = 0;
        private int m_dataSize = 0;
        private int m_configSize = 0;
        private const int ConfigAddressBL = 0x0FFF;    // Logical Address of Configuration in BaseLine Family

        public PicMemory()
        {
	        //m_nProgSize2=0;
	        //m_nConfSize2=0;
	        //m_nDataSize2=0;

            //m_ProgMemAddr = 0x0000;
            //m_ConfMemAddr = 0x4000;
            //m_DataMemAddr = 0x4200;
	
            ProgMem=null;
            DataMem=null;
            ConfMem=null;
	
            //m_pHexLine=null;
        }

        public PicMemory(PicDevice D)
        {
            //if (D == null)
            //    return false;

            Device = D;

            //if ((Device.ProgSize >= (Device.ConfMemAddr - Device.ProgMemAddr) / 2) ||
            //    (Device.ConfSize >= (Device.DataMemAddr - Device.ConfMemAddr) / 2) ||
            //    (Device.DataSize >= 0x1000)) // for margin
            //{
            //    ProgMem = null;
            //    DataMem = null;
            //    ConfMem = null;
            //    //return false;
            //}
            //else
            //{
            if (Device.ProgSize > 0)
                ProgMem = new Int16[Device.ProgSize];
            if (Device.DataSize > 0)
                DataMem = new Int16[Device.DataSize];
            if (Device.ConfDspSize > 0)
                ConfMem = new Int16[Device.ConfDspSize];

            for (int i = 0; i < Device.ProgSize; i++)
                ProgMem[i] = Device.ProgMask;

            for (int i = 0; i < Device.DataSize; i++)
                DataMem[i] = Device.DataMask;

            for (int i = 0; i < Device.ConfDspSize; i++)
                ConfMem[i] = Device.ProgMask;
            //}

            CalibDatas = new Int16[Device.CalibAddrs.Length];

            ////return true;

        }


        /*
        public ~PicMemory()
        {
            if (m_pProgArea)
                delete [] m_pProgArea;
            if (m_pDataArea)
                delete [] m_pDataArea;
            if (m_pConfArea)
                delete [] m_pConfArea;
            if (m_pHexLine)
                delete m_pHexLine;
        }
         */
  
        //public PicDevice  GetDevice(){
        //    return Device;
        //}



        public bool LoadFromFile(StreamReader sr)
        {
            HexLine myHexLine = new HexLine(sr);
            //String buf;
            //m_pHexLine = new IntelHex(this);
            bool bstatus;
            int status = 0;
            while (status == 0 )
            {
                uint addr;
                Int16[] Word;
                status = myHexLine.ReadWord(out addr, out Word);
                if (status == 0)
                {
                    //if (Device.Family == PICFAMILY.PIC16EnhFamily)
                    //    bstatus = Store16E(addr,Word);
                    //else
                        bstatus = Store(addr, Word);

                    if(bstatus)
                        continue;
                    else
                        return false;
                }
            }
            if (status == 1)
                return true;
            else
                return false;
        }

        private bool Store(uint addr, Int16[] word)
        {
	        int offset;
            if (addr >= Device.DataAddr)
            {		// EEPDATA
                offset = (int)(addr - Device.DataAddr);
                if (offset < Device.DataSize)
                {
                    for (int i = 0; i < word.Length; i++)
                        DataMem[offset++] = word[i];

                    if (offset > m_dataSize)
                    {
                        m_dataSize = offset;
                    }
                }
                else
                    return false;
            }
            //else if(addr >= 0x3ffffe){	// DeviceID
            //    offset = addr - 0x3ffffe;
            //    if(offset < sizeof(m_DeviceID)){
            //        m_DeviceID[offset++] = data;

            //    }
            //}
            else if (addr >= Device.IDAddr)
            {	// ID & Configuration
                if (Device.Family == PICFAMILY.PICBaseLineFamily && addr == ConfigAddressBL)
                {
                    ConfMem[ConfMem.Length-1] = word[0];
                }
                else
                {   // PIC16 Midrange & PIC16 Enhanced & (BaseLine UserID)
                    offset = (int)(addr - Device.IDAddr);
                    if (offset < Device.ConfDspSize)
                    {
                        for (int i = 0; i < word.Length; i++)
                            ConfMem[offset++] = word[i];

                        if (offset > m_configSize)
                        {
                            m_configSize = offset;
                        }
                    }
                    else
                        return false;
                }
            }
            //else if(addr >= 0x200000){	// ID Locations
            //    offset = addr - 0x200000;
            //    if(offset < sizeof(m_UserID)){
            //        m_UserID[offset++] = data;

            //    }
            //}
            else
            {						// Code
                offset = (int)addr;
                if (offset < Device.ProgSize)
                {
                    for (int i = 0; i < word.Length; i++)
                    {
                        if (offset >= Device.ProgSize)
                            return false;
                        ProgMem[offset++] = word[i];
                    }
                    if (offset > m_codeSize)
                    {
                        m_codeSize = offset;
                    }
                }
                else
                    return false;
            }
            return true;
        }

        private bool Store16E(uint addr, Int16[] word)
        {
            int offset;
            if (addr >= 0xF000)
            {		// EEPDATA
                offset = (int)(addr - 0xF000);
                if (offset < Device.DataSize)
                {
                    for (int i = 0; i < word.Length; i++)
                        DataMem[offset++] = word[i];

                    if (offset > m_dataSize)
                    {
                        m_dataSize = offset;
                    }
                }
                else
                    return false;
            }
            //else if(addr >= 0x3ffffe){	// DeviceID
            //    offset = addr - 0x3ffffe;
            //    if(offset < sizeof(m_DeviceID)){
            //        m_DeviceID[offset++] = data;

            //    }
            //}
            else if (addr >= 0x8000)
            {	// Configuration
                offset = (int)(addr - 0x8000);
                if (offset < Device.ConfDspSize)
                {
                    for (int i = 0; i < word.Length; i++)
                        ConfMem[offset++] = word[i];

                    if (offset > m_configSize)
                    {
                        m_configSize = offset;
                    }
                }
                else
                    return false;

            }
            //else if(addr >= 0x200000){	// ID Locations
            //    offset = addr - 0x200000;
            //    if(offset < sizeof(m_UserID)){
            //        m_UserID[offset++] = data;

            //    }
            //}
            else
            {						// Code
                offset = (int)addr;
                if (offset < Device.ProgSize)
                {
                    for (int i = 0; i < word.Length; i++)
                    {
                        if (offset >= Device.ProgSize)
                            return false;
                        ProgMem[offset++] = word[i];
                    }
                    if (offset > m_codeSize)
                    {
                        m_codeSize = offset;
                    }
                }
                else
                    return false;
            }
            return true;
        }


 
        public bool saveToFile(StreamWriter sw)
        {
	        HexLine hex = new HexLine(sw);
	
	        //sw.WriteLine(":020000040000FA");

            //if (Device.Family == PICFAMILY.PIC16EnhFamily)
            //{
            //    writedata(hex, 0x0000, ProgMem, Device.ProgMask);
            //    writedata(hex, 0x8000, ConfMem, Device.ProgMask);
            //    writedata(hex, 0xF000, DataMem, Device.DataMask);
            //}
            //else
            //{
                int Size = ProgMem.Length;
                if (Device.CalibAddrs.Length > 0)
                    if (Device.CalibAddrs[0] > 0 && Device.CalibAddrs[0] < 0x1000)
                        Size--;
                WriteData(hex, 0x0000, ProgMem, Device.ProgMask, 0, Size);
                //bool Ignore = true;
                //for(int i=0; i<4; i++)
                //{
                //    if(
                // User ID
                WriteData(hex, (uint)Device.IDAddr, ConfMem, Device.UIDMask, 0, 4);
                // Configration 
                Int16[] Buf = new Int16[2];
                Size = 1;
                Buf[0] = (Int16)(ConfMem[Device.ConfAddr[0] - Device.IDAddr] & Device.ConfMask[0]);
                if (Device.ConfAddr.Length > 1)
                {
                    Size++;
                    Buf[1] = (Int16)(ConfMem[Device.ConfAddr[1] - Device.IDAddr] & Device.ConfMask[1]);
                }
                WriteData(hex, (uint)Device.ConfAddr[0], Buf, Device.ProgMask, 0, Size);  
                // DAta
                WriteData(hex, (uint)Device.DataAddr, DataMem, Device.DataMask, 0, 0);
            //}
	        sw.WriteLine(":00000001FF");
	
	        return true;
        }

        private void WriteData(HexLine hex, uint addr, Int16[] word, Int16 mask, int ioffset, int size)
        {
            Int16[] buf;
            
            bool ignore;
            int i, j, k;
            int count = size == 0 ? word.Length : size;
            if(count < 8)
                buf = new Int16[count];
            else
                buf = new Int16[8];

            for (i = 0; i < count; )
            {
                k = i;
                ignore = true;
                for (j = 0; (j < 8) && (i < count); i++, j++)
                {
                    if ((word[i + ioffset] & mask) == mask)
                        ;
                    else
                        ignore = false;
                    buf[j] = (Int16)(word[i + ioffset] & mask);
                }
                if (!ignore)
                {
                    if (j < buf.Length)
                    {
                        for (; j < buf.Length; j++)
                            buf[j] = mask;
                    }
                    hex.writeWord((uint)(addr + k), buf);
                }
                ////		if (!ignore){
                ////			for (j=16;j>0;j--)
                ////				if (buf[j-1]==0xff);
                ////				else break;
                //            hex.writeData(addr+k,j,buf);
                ////		}
            }
        }

    }
}
